From 3f2d59b4fb31fce66db650ed80957bb481035a89 Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Thu, 15 Jul 2021 23:23:37 +0000
Subject: [PATCH] [arm64] port sad

            sad[  4x4]	10.34x 	 6.50     	 67.22
            sad[  8x8]	29.96x 	 8.47     	 253.70
            sad[  8x4]	22.66x 	 5.63     	 127.55
            sad[  4x8]	12.32x 	 10.65    	 131.15
            sad[16x16]	53.10x 	 19.21    	 1019.88
            sad[ 16x8]	42.92x 	 11.67    	 500.92
            sad[ 8x16]	31.06x 	 16.95    	 526.65
            sad[ 16x4]	39.68x 	 6.29     	 249.54
            sad[16x12]	51.23x 	 14.93    	 764.86
            sad[ 4x16]	14.22x 	 19.40    	 275.78
            sad[12x16]	33.53x 	 23.00    	 770.98
            sad[32x32]	61.94x 	 64.99    	 4025.60
            sad[32x16]	59.88x 	 33.75    	 2021.13
            sad[16x32]	57.91x 	 35.01    	 2027.56
            sad[ 32x8]	54.38x 	 18.52    	 1007.22
            sad[32x24]	60.30x 	 50.10    	 3021.16
            sad[ 8x32]	31.85x 	 32.53    	 1036.03
            sad[24x32]	53.52x 	 56.45    	 3021.14
            sad[64x64]	65.07x 	 256.56   	 16693.77
            sad[64x32]	61.51x 	 131.70   	 8100.61
            sad[32x64]	62.36x 	 128.91   	 8039.52
            sad[64x16]	59.15x 	 68.53    	 4053.45
            sad[64x48]	62.56x 	 194.49   	 12166.57
            sad[16x64]	61.14x 	 66.12    	 4042.20
            sad[48x64]	62.24x 	 193.20   	 12024.60
---
 source/common/aarch64/asm-primitives.cpp |  27 +++
 source/common/aarch64/pixel.h            |  27 +++
 source/common/aarch64/sad-a.S            | 294 +++++++++++++++++++++++
 3 files changed, 348 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 5a582b6..3b7e7b1 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -161,6 +161,33 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_64x48].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x48_neon);
         p.pu[LUMA_64x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x64_neon);
 
+        // sad
+        p.pu[LUMA_4x4].sad    = PFX(pixel_sad_4x4_neon);
+        p.pu[LUMA_4x8].sad    = PFX(pixel_sad_4x8_neon);
+        p.pu[LUMA_4x16].sad   = PFX(pixel_sad_4x16_neon);
+        p.pu[LUMA_8x4].sad    = PFX(pixel_sad_8x4_neon);
+        p.pu[LUMA_8x8].sad    = PFX(pixel_sad_8x8_neon);
+        p.pu[LUMA_8x16].sad   = PFX(pixel_sad_8x16_neon);
+        p.pu[LUMA_8x32].sad   = PFX(pixel_sad_8x32_neon);
+        p.pu[LUMA_16x4].sad   = PFX(pixel_sad_16x4_neon);
+        p.pu[LUMA_16x8].sad   = PFX(pixel_sad_16x8_neon);
+        p.pu[LUMA_16x16].sad  = PFX(pixel_sad_16x16_neon);
+        p.pu[LUMA_16x12].sad  = PFX(pixel_sad_16x12_neon);
+        p.pu[LUMA_16x32].sad  = PFX(pixel_sad_16x32_neon);
+        p.pu[LUMA_16x64].sad  = PFX(pixel_sad_16x64_neon);
+        p.pu[LUMA_32x8].sad   = PFX(pixel_sad_32x8_neon);
+        p.pu[LUMA_32x16].sad  = PFX(pixel_sad_32x16_neon);
+        p.pu[LUMA_32x32].sad  = PFX(pixel_sad_32x32_neon);
+        p.pu[LUMA_32x64].sad  = PFX(pixel_sad_32x64_neon);
+        p.pu[LUMA_32x24].sad  = PFX(pixel_sad_32x24_neon);
+        p.pu[LUMA_64x16].sad  = PFX(pixel_sad_64x16_neon);
+        p.pu[LUMA_64x32].sad  = PFX(pixel_sad_64x32_neon);
+        p.pu[LUMA_64x64].sad  = PFX(pixel_sad_64x64_neon);
+        p.pu[LUMA_64x48].sad  = PFX(pixel_sad_64x48_neon);
+        p.pu[LUMA_12x16].sad  = PFX(pixel_sad_12x16_neon);
+        p.pu[LUMA_24x32].sad  = PFX(pixel_sad_24x32_neon);
+        p.pu[LUMA_48x64].sad  = PFX(pixel_sad_48x64_neon);
+
         // vertical interpolation filters
         p.pu[LUMA_4x4].luma_vpp     = PFX(interp_8tap_vert_pp_4x4_neon);
         p.pu[LUMA_4x8].luma_vpp     = PFX(interp_8tap_vert_pp_4x8_neon);
diff --git a/source/common/aarch64/pixel.h b/source/common/aarch64/pixel.h
index 179c2f4..8065b4a 100644
--- a/source/common/aarch64/pixel.h
+++ b/source/common/aarch64/pixel.h
@@ -2,6 +2,7 @@
  * Copyright (C) 2020 MulticoreWare, Inc
  *
  * Authors: Hongbin Liu <liuhongbin1@huawei.com>
+ *          Sebastian Pop <spop@amazon.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -24,6 +25,32 @@
 #ifndef X265_I386_PIXEL_AARCH64_H
 #define X265_I386_PIXEL_AARCH64_H
 
+int x265_pixel_sad_4x4_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_4x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_4x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x4_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_8x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x4_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x12_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_16x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x8_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_32x24_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_64x48_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_12x16_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_24x32_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+int x265_pixel_sad_48x64_neon(const pixel* dst, intptr_t dstStride, const pixel* src, intptr_t srcStride);
+
 void x265_pixel_avg_pp_4x4_neon (pixel* dst, intptr_t dstride, const pixel* src0, intptr_t sstride0, const pixel* src1, intptr_t sstride1, int);
 void x265_pixel_avg_pp_4x8_neon (pixel* dst, intptr_t dstride, const pixel* src0, intptr_t sstride0, const pixel* src1, intptr_t sstride1, int);
 void x265_pixel_avg_pp_4x16_neon (pixel* dst, intptr_t dstride, const pixel* src0, intptr_t sstride0, const pixel* src1, intptr_t sstride1, int);
diff --git a/source/common/aarch64/sad-a.S b/source/common/aarch64/sad-a.S
index c27cce5..67b358c 100644
--- a/source/common/aarch64/sad-a.S
+++ b/source/common/aarch64/sad-a.S
@@ -2,6 +2,7 @@
  * Copyright (C) 2020 MulticoreWare, Inc
  *
  * Authors: Hongbin Liu <liuhongbin1@huawei.com>
+ *          Sebastian Pop <spop@amazon.com>
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -29,6 +30,295 @@
 
 .text
 
+.macro SAD_START_4 f
+    ld1             {v1.s}[0], [x2], x3
+    ld1             {v0.s}[0], [x0], x1
+    ld1             {v1.s}[1], [x2], x3
+    ld1             {v0.s}[1], [x0], x1
+    \f              v16.8h, v0.8b, v1.8b
+.endm
+
+.macro SAD_4 h
+.rept \h / 2 - 1
+    SAD_START_4 uabal
+.endr
+.endm
+
+.macro SAD_START_8 f
+    ld1             {v0.8b}, [x0], x1
+    ld1             {v1.8b}, [x2], x3
+    ld1             {v2.8b}, [x0], x1
+    ld1             {v3.8b}, [x2], x3
+    \f              v16.8h, v0.8b, v1.8b
+    \f              v17.8h, v2.8b, v3.8b
+.endm
+
+.macro SAD_8 h
+.rept \h / 2 - 1
+    SAD_START_8 uabal
+.endr
+.endm
+
+.macro SAD_START_16 f
+    ld1             {v0.16b}, [x0], x1
+    ld1             {v1.16b}, [x2], x3
+    ld1             {v2.16b}, [x0], x1
+    ld1             {v3.16b}, [x2], x3
+    \f              v16.8h, v0.8b, v1.8b
+    \f\()2          v17.8h, v0.16b, v1.16b
+    uabal           v16.8h, v2.8b, v3.8b
+    uabal2          v17.8h, v2.16b, v3.16b
+.endm
+
+.macro SAD_16 h
+.rept \h / 2 - 1
+    SAD_START_16 uabal
+.endr
+.endm
+
+.macro SAD_START_32
+    movi            v16.16b, #0
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+    movi            v19.16b, #0
+.endm
+
+.macro SAD_32
+    ld1             {v0.16b-v1.16b}, [x0], x1
+    ld1             {v2.16b-v3.16b}, [x2], x3
+    ld1             {v4.16b-v5.16b}, [x0], x1
+    ld1             {v6.16b-v7.16b}, [x2], x3
+    uabal           v16.8h, v0.8b, v2.8b
+    uabal2          v17.8h, v0.16b, v2.16b
+    uabal           v18.8h, v1.8b, v3.8b
+    uabal2          v19.8h, v1.16b, v3.16b
+    uabal           v16.8h, v4.8b, v6.8b
+    uabal2          v17.8h, v4.16b, v6.16b
+    uabal           v18.8h, v5.8b, v7.8b
+    uabal2          v19.8h, v5.16b, v7.16b
+.endm
+
+.macro SAD_END_32
+    add             v16.8h, v16.8h, v17.8h
+    add             v17.8h, v18.8h, v19.8h
+    add             v16.8h, v16.8h, v17.8h
+    uaddlv          s0, v16.8h
+    fmov            w0, s0
+    ret
+.endm
+
+.macro SAD_START_64
+    movi            v16.16b, #0
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+    movi            v19.16b, #0
+    movi            v20.16b, #0
+    movi            v21.16b, #0
+    movi            v22.16b, #0
+    movi            v23.16b, #0
+.endm
+
+.macro SAD_64
+    ld1             {v0.16b-v3.16b}, [x0], x1
+    ld1             {v4.16b-v7.16b}, [x2], x3
+    ld1             {v24.16b-v27.16b}, [x0], x1
+    ld1             {v28.16b-v31.16b}, [x2], x3
+    uabal           v16.8h, v0.8b, v4.8b
+    uabal2          v17.8h, v0.16b, v4.16b
+    uabal           v18.8h, v1.8b, v5.8b
+    uabal2          v19.8h, v1.16b, v5.16b
+    uabal           v20.8h, v2.8b, v6.8b
+    uabal2          v21.8h, v2.16b, v6.16b
+    uabal           v22.8h, v3.8b, v7.8b
+    uabal2          v23.8h, v3.16b, v7.16b
+
+    uabal           v16.8h, v24.8b, v28.8b
+    uabal2          v17.8h, v24.16b, v28.16b
+    uabal           v18.8h, v25.8b, v29.8b
+    uabal2          v19.8h, v25.16b, v29.16b
+    uabal           v20.8h, v26.8b, v30.8b
+    uabal2          v21.8h, v26.16b, v30.16b
+    uabal           v22.8h, v27.8b, v31.8b
+    uabal2          v23.8h, v27.16b, v31.16b
+.endm
+
+.macro SAD_END_64
+    add             v16.8h, v16.8h, v17.8h
+    add             v17.8h, v18.8h, v19.8h
+    add             v16.8h, v16.8h, v17.8h
+    uaddlp          v16.4s, v16.8h
+    add             v18.8h, v20.8h, v21.8h
+    add             v19.8h, v22.8h, v23.8h
+    add             v17.8h, v18.8h, v19.8h
+    uaddlp          v17.4s, v17.8h
+    add             v16.4s, v16.4s, v17.4s
+    uaddlv          d0, v16.4s
+    fmov            x0, d0
+    ret
+.endm
+
+.macro SAD_START_12
+    movrel          x12, sad12_mask
+    ld1             {v31.16b}, [x12]
+    movi            v16.16b, #0
+    movi            v17.16b, #0
+.endm
+
+.macro SAD_12
+    ld1             {v0.16b}, [x0], x1
+    and             v0.16b, v0.16b, v31.16b
+    ld1             {v1.16b}, [x2], x3
+    and             v1.16b, v1.16b, v31.16b
+    ld1             {v2.16b}, [x0], x1
+    and             v2.16b, v2.16b, v31.16b
+    ld1             {v3.16b}, [x2], x3
+    and             v3.16b, v3.16b, v31.16b
+    uabal           v16.8h, v0.8b, v1.8b
+    uabal2          v17.8h, v0.16b, v1.16b
+    uabal           v16.8h, v2.8b, v3.8b
+    uabal2          v17.8h, v2.16b, v3.16b
+.endm
+
+.macro SAD_END_12
+    add             v16.8h, v16.8h, v17.8h
+    uaddlv          s0, v16.8h
+    fmov            w0, s0
+    ret
+.endm
+
+.macro SAD_START_24
+    movi            v16.16b, #0
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+    sub             x1, x1, #16
+    sub             x3, x3, #16
+.endm
+
+.macro SAD_24
+    ld1             {v0.16b}, [x0], #16
+    ld1             {v1.8b}, [x0], x1
+    ld1             {v2.16b}, [x2], #16
+    ld1             {v3.8b}, [x2], x3
+    ld1             {v4.16b}, [x0], #16
+    ld1             {v5.8b}, [x0], x1
+    ld1             {v6.16b}, [x2], #16
+    ld1             {v7.8b}, [x2], x3
+    uabal           v16.8h, v0.8b, v2.8b
+    uabal2          v17.8h, v0.16b, v2.16b
+    uabal           v18.8h, v1.8b, v3.8b
+    uabal           v16.8h, v4.8b, v6.8b
+    uabal2          v17.8h, v4.16b, v6.16b
+    uabal           v18.8h, v5.8b, v7.8b
+.endm
+
+.macro SAD_END_24
+    add             v16.8h, v16.8h, v17.8h
+    add             v16.8h, v16.8h, v18.8h
+    uaddlv          s0, v16.8h
+    fmov            w0, s0
+    ret
+.endm
+
+.macro SAD_START_48
+    movi            v16.16b, #0
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+    movi            v19.16b, #0
+    movi            v20.16b, #0
+    movi            v21.16b, #0
+.endm
+
+.macro SAD_48
+    ld1             {v0.16b-v2.16b}, [x0], x1
+    ld1             {v4.16b-v6.16b}, [x2], x3
+    ld1             {v24.16b-v26.16b}, [x0], x1
+    ld1             {v28.16b-v30.16b}, [x2], x3
+    uabal           v16.8h, v0.8b, v4.8b
+    uabal2          v17.8h, v0.16b, v4.16b
+    uabal           v18.8h, v1.8b, v5.8b
+    uabal2          v19.8h, v1.16b, v5.16b
+    uabal           v20.8h, v2.8b, v6.8b
+    uabal2          v21.8h, v2.16b, v6.16b
+
+    uabal           v16.8h, v24.8b, v28.8b
+    uabal2          v17.8h, v24.16b, v28.16b
+    uabal           v18.8h, v25.8b, v29.8b
+    uabal2          v19.8h, v25.16b, v29.16b
+    uabal           v20.8h, v26.8b, v30.8b
+    uabal2          v21.8h, v26.16b, v30.16b
+.endm
+
+.macro SAD_END_48
+    add             v16.8h, v16.8h, v17.8h
+    add             v17.8h, v18.8h, v19.8h
+    add             v16.8h, v16.8h, v17.8h
+    uaddlv          s0, v16.8h
+    fmov            w0, s0
+    add             v18.8h, v20.8h, v21.8h
+    uaddlv          s1, v18.8h
+    fmov            w1, s1
+    add             w0, w0, w1
+    ret
+.endm
+
+// Fully unrolled.
+.macro SAD_FUNC w, h
+function x265_pixel_sad_\w\()x\h\()_neon
+    SAD_START_\w uabdl
+    SAD_\w \h
+.if \w > 4
+    add             v16.8h, v16.8h, v17.8h
+.endif
+    uaddlv          s0, v16.8h
+    fmov            w0, s0
+    ret
+endfunc
+.endm
+
+// Loop unrolled 4.
+.macro SAD_FUNC_LOOP w, h
+function x265_pixel_sad_\w\()x\h\()_neon
+    SAD_START_\w
+
+    mov             w9, #\h/8
+.loop_\w\()x\h:
+    sub             w9, w9, #1
+.rept 4
+    SAD_\w
+.endr
+    cbnz            w9, .loop_\w\()x\h
+
+    SAD_END_\w
+endfunc
+.endm
+
+SAD_FUNC  4,  4
+SAD_FUNC  4,  8
+SAD_FUNC  4,  16
+SAD_FUNC  8,  4
+SAD_FUNC  8,  8
+SAD_FUNC  8,  16
+SAD_FUNC  8,  32
+SAD_FUNC  16, 4
+SAD_FUNC  16, 8
+SAD_FUNC  16, 12
+SAD_FUNC  16, 16
+SAD_FUNC  16, 32
+SAD_FUNC  16, 64
+
+SAD_FUNC_LOOP  32, 8
+SAD_FUNC_LOOP  32, 16
+SAD_FUNC_LOOP  32, 24
+SAD_FUNC_LOOP  32, 32
+SAD_FUNC_LOOP  32, 64
+SAD_FUNC_LOOP  64, 16
+SAD_FUNC_LOOP  64, 32
+SAD_FUNC_LOOP  64, 48
+SAD_FUNC_LOOP  64, 64
+SAD_FUNC_LOOP  12, 16
+SAD_FUNC_LOOP  24, 32
+SAD_FUNC_LOOP  48, 64
+
 .macro SAD_X_START_8 x
     ld1             {v0.8b}, [x0], x9
 .if \x == 3
@@ -103,3 +393,7 @@ SAD_X_8xN 4 4
 SAD_X_8xN 4 8
 SAD_X_8xN 4 16
 SAD_X_8xN 4 32
+
+const sad12_mask, align=8
+.byte 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 0, 0, 0, 0
+endconst
-- 
2.25.1

